#pragma once

#include <fltKernel.h>
#include <dontuse.h>
#include <suppress.h>

#include <ntddk.h>

#pragma prefast(disable:__WARNING_ENCODE_MEMBER_FUNCTION_POINTER, "Not valid for kernel mode drivers")

NTSTATUS DriverEntry(
	IN PDRIVER_OBJECT DriverObject,
	IN PUNICODE_STRING RegistryPath
);

NTSTATUS FsFilterLoad(
	IN PCFLT_RELATED_OBJECTS  FltObjects,
	IN FLT_INSTANCE_SETUP_FLAGS  Flags,
	IN DEVICE_TYPE  VolumeDeviceType,
	IN FLT_FILESYSTEM_TYPE  VolumeFilesystemType
);

NTSTATUS FsFilterUnload(IN FLT_FILTER_UNLOAD_FLAGS Flags);

FLT_PREOP_CALLBACK_STATUS FsFilterPreOperation(
	IN OUT PFLT_CALLBACK_DATA Data,
	IN PCFLT_RELATED_OBJECTS FltObjects,
	_Flt_CompletionContext_Outptr_ PVOID *CompletionContext
);

/*
FLT_POSTOP_CALLBACK_STATUS FsFilterPostOperation(
	IN OUT PFLT_CALLBACK_DATA Data,
	IN PCFLT_RELATED_OBJECTS FltObjects,
	IN OPTIONAL PVOID CompletionContext,
	IN FLT_POST_OPERATION_FLAGS Flags
);
*/

#pragma alloc_text(INIT, DriverEntry)
#pragma alloc_text(PAGE, FsFilterLoad)
#pragma alloc_text(PAGE, FsFilterUnload)
#pragma alloc_text(PAGE, FsFilterPreOperation)